project_dir = File.expand_path("..", File.dirname(__FILE__))
require File.join(project_dir, 'custom/versions')

module AbasBpm
    class Checks < Abas::CheckCollection
  
      def initialize(data)
        super()
        @factory = CheckFactory.new(data)

        credential_check = @factory.credential_check()
        
        engine_artifact_check = @factory.engine_artifact_check()
        engine_artifact_check.add_condition(credential_check)
  
        add_pre_install_checks([
          @factory.install_dir_not_exists_check(),
          @factory.disk_space_check(),
          @factory.engine_port_free_check(),
          @factory.db_port_free_check(),
          credential_check,
          engine_artifact_check,
        ])

        add_post_install_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.user_check(),
        ])

        add_runtime_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.user_check(),
          @factory.engine_running_check(),
          @factory.engine_port_used_check(),
          @factory.db_running_check(),
          @factory.db_port_used_check(),
        ] + @factory.edp_configuration_checks())

        add_pre_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.user_check(),
          @factory.engine_port_free_check(),
          @factory.db_port_free_check(),
          credential_check,
          engine_artifact_check,
        ])

        add_post_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.user_check(),
        ])
      end
  
    end
  end