module AbasBpm
    class EdpClientDirCheck < Abas::Check

        attr_accessor :ip, :port, :client_dir, :container_name

        def initialize
            super
            action do |check_result|
                exec_result = `docker exec -t #{@container_name} bash -c 'printf "chm||#{@client_dir}" | nc #{@ip} #{@port}' | grep -0 'ACK|1|' | wc -l`
                success =  exec_result.strip == '1'
    
                if success
                    check_result.success()
                else
                    check_result.failure("Could not change to client #{@client_dir} using EDP #{@ip}:#{@port} from within the #{@container_name} container.")
                end
            end
        end
      
        def self.create(name:, ip:, port:, client_dir:, container_name:)
            instance = EdpClientDirCheck.new
            instance.name = name
            instance.ip = ip
            instance.port = port
            instance.client_dir = client_dir
            instance.container_name = container_name
            return instance
        end
    end
end