module AbasBpm
    class EdpConnectionCheck < Abas::Check

        attr_accessor :ip, :port, :container_name

        def initialize
            super
      
            action do |check_result|
                exec_result = `docker exec -t #{@container_name} bash -c 'printf "" | nc #{@ip} #{@port}' | grep -0 'S|0|3|VERSION' | wc -l`
                success =  exec_result.strip == '1'
    
                if success
                    check_result.success()
                else
                    check_result.failure("Could not establish connection to EDP at #{@ip}:#{@port} from within the #{@container_name} container.")
                end
            end
        end
      
        def self.create(name:, ip:, port:, container_name:)
            instance = EdpConnectionCheck.new
            instance.name = name
            instance.ip = ip
            instance.port = port
            instance.container_name = container_name
            return instance
        end
    end
end