module AbasBpm
    class WebuserApiKeyCheck < Abas::Check

        attr_accessor :ip, :port, :client_dir, :password, :container_name, :database_container_name, :database_user_name

        def initialize
            super

            action do |check_result|
                exec_result = `docker exec -t #{@container_name} bash -c 'printf "chm||#{@client_dir}\nlgn||#{@password}\nexq|0|93:1,login=abas-bpm|name,login,email" | nc #{@ip} #{@port}' | grep -0 'abas-bpm'`.strip
                api_key = exec_result.split('|')[4]

                psql_result = `docker exec -t #{@database_container_name} psql -U #{@database_user_name} -d camunda -t -c "SELECT api_key_ from abas_bpm_apikey where api_key_ = '#{api_key}'"`.strip
                success = psql_result.include? api_key

                if success
                    check_result.success()
                else
                    check_result.failure("The provided api key is not valid for the defined abas BPM engine.")
                end
            end
        end
      
        def self.create(name:, ip:, port:, client_dir:, password:, container_name:, database_container_name:, database_user_name:)
            instance = WebuserApiKeyCheck.new
            instance.name = name
            instance.ip = ip
            instance.port = port
            instance.client_dir = client_dir
            instance.password = password
            instance.container_name = container_name
            instance.database_container_name = database_container_name
            instance.database_user_name = database_user_name
            return instance
        end
    end
end