module AbasBpm
    class WebuserUrlCheck < Abas::Check

        attr_accessor :ip, :port, :client_dir, :password, :container_name, :engine_url

        def initialize
            super
            action do |check_result|
                exec_result = `docker exec -t #{@container_name} bash -c 'printf "chm||#{@client_dir}\nlgn||#{@password}\nexq|0|93:1,login=abas-bpm|name,login,email" | nc #{@ip} #{@port}' | grep -0 'abas-bpm'`
                exec_result = exec_result.strip.split('|')[2]
                success =  exec_result == @engine_url

                if success
                    check_result.success()
                else
                    check_result.failure("The provided url to the abas BPM engine #{exec_result} is not equal to the expected url #{@engine_url}.")
                end
            end
        end
      
        def self.create(name:, ip:, port:, client_dir:, password:, container_name:, engine_url:)
            instance = WebuserUrlCheck.new
            instance.name = name
            instance.ip = ip
            instance.port = port
            instance.client_dir = client_dir
            instance.password = password
            instance.container_name = container_name
            instance.engine_url = engine_url
            return instance
        end
    end
end