module AbasBpm
    class Versions
        def self.all()
            versions = {
                '1.0.0' => {
                    'engine_version' => '1.0.0-b464',
                    'ui_version' => '1.0.0-b1121'
                },
                '1.1.0' => {
                    'engine_version' => '1.1.0-b861',
                    'ui_version' => '1.1.0-b1259'
                },
                '1.1.1' => {
                    'engine_version' => '1.1.1-b910',
                    'ui_version' => '1.1.0-b1259'
                },
            }
            return versions
        end

        def self.ui_version(version:)
            versions = self.all()
            return versions[version]['ui_version'] if versions[version]
        end

        def self.engine_version(version:)
            versions = self.all()
            return versions[version]['engine_version'] if versions[version]
        end

        def self.find_version(engine_version:)
            self.all().each do |key, value| 
                return key if value['engine_version'] == engine_version
            end
        end
    end
end
