# abas_bpm.rb
require 'yaml' # import

module AbasBpm
  class AbasBpmService

    RUNNING = :running
    STOPPED = :stopped
    MISSING = :missing
    FAILURE = :failure

    def initialize(resolved_config)
        @resolved_config = resolved_config
        @install_dir = resolved_config['install_dir']
    end

    def exists?
        return File.file?(File.join(@install_dir, "/docker-compose.yml"))
    end

    def status
      if exists?
        result = `cd #{@install_dir} && docker-compose ps -q`

        case result.lines.count
        when 0
          return STOPPED
        when 2
          return RUNNING
        else
          return FAILURE
        end
      else
        return MISSING
      end
    end

    def start
      `cd #{@install_dir} && docker-compose up -d --force-recreate`
    end

    def stop
      `cd #{@install_dir} && docker-compose down`
    end
  end
end