class bpm(String $module_id) {

  $data = abas::inspect($module_id)

  $config                 = $data['config']
  $install_dir            = $config['install_dir']
  $user                   = $config['user']

  user { $user:
    ensure     => 'present',
    managehome => true,
    groups     => ['docker'],
  }
  -> exec { "Recursively create ${install_dir}":
    command => "mkdir -p ${install_dir}",
    path    => ['/bin', '/usr/bin'],
  }
  -> file { $install_dir:
    ensure => directory,
    owner  => $user,
  }
  -> bpm::resolve_templates { 'resolve_templates':
    data    => $data,
  }
  -> bpm::pull_containers { 'pull_containers':
    data    => $data,
  }
}
