define bpm::pull_containers($data) {

  $config             = $data['config']
  $install_dir        = $config['install_dir']
  $user               = $config['user']
  $authentication     = $config['authentication']

  $registry_credentials   = abas::credentials($authentication["registry_credentials"])
  $registry_username      = $registry_credentials["username"]
  $registry_password      = $registry_credentials["password"]

  exec { "DOCKER: Login user to docker.registry.abas.sh using ${user}":
    onlyif    => ["[ ${registry_username} ] && [ ${registry_password} ] || exit 1"],
    command   => "docker login docker.registry.abas.sh -u '${registry_username}' -p '${registry_password}'",
    logoutput => true,
    path      => '/usr/bin',
    user      => $user,
  }
  -> exec { 'DOCKER: Pull latest engine':
    command => 'docker-compose pull',
    cwd     => $install_dir,
    path    => '/usr/local/bin',
    user    => $user,
  }
}
