module AbasBpm
  require File.join(File.dirname(__FILE__), 'custom/versions')

  class Outputs

    def initialize(module_data)
      @config     = module_data['config']
      @host       = module_data['host']
    end

    def hostname
      return @host['Properties']['hostname']
    end

    def host_ip
      return @host['Properties']['ip']
    end    

    def port
      return @config['setup']['engine_port']
    end

    def webserver_artifact_coordinate
      selected_ui_version = AbasBpm::Versions.ui_version(version: @config['setup']['version'])
      if @config['developer_settings']['ui_version']
        selected_ui_version = @config['developer_settings']['ui_version']
      end
      return "abas.releases:de.abas.bpm:ui:#{selected_ui_version}"
    end
  end
end