class client(String $module_id) {

  $data = abas::inspect($module_id)

  $module_version     = $data['metadata']["Version"]
  $config             = $data['config']
  $path               = $config['name']
  $erp                = $config['erp']
  $erp_version_year   = $erp['version_year']
  $dockerized         = $erp['dockerized']
  $homedir            = $erp['homedir']
  $homebase           = $erp['homebase']
  $s3_user            = $erp['s3_user']
  $s3_group           = $erp['group_name']
  $container_name     = $erp['container_name']
  $mname              = $config['mname']
  $mandant            = $config['mandant']
  $base_mandantdir    = $config['base_mandantdir']
  $suffix_mandantdir  = $config['suffix_mandantdir']
  $create_mode        = $config['create_mode']
  $no_backup          = $config['no_backup']
  $archive_url        = $config['archive_url']
  $diag_email_config  = $config['diag_email_config']

  $workdir = "/opt/abas-installer-workdir/workdir/client/$mname"
  $archive_file = "${workdir}/${mname}.tgz"

  if  ($base_mandantdir != undef) and ($base_mandantdir != '') {
    fail('Parameter base_mandantdir is not supported during installation, only to describe present installations.')
  }


  exec { 'create workdir':
    command => "mkdir -p $workdir",
    path => ['/bin', '/usr/bin']
  }

  exec { 'download archive':
    command => "/usr/bin/curl ${archive_url} -o ${archive_file}",
    cwd     => "$workdir",
    user    => 'root',
    onlyif  => "/usr/bin/test -n '${archive_url}'",
  }


  if $dockerized {
    contain client::install_dockerized
  } else {
    contain client::install_native
  }

}
