class client_configuration (
  String $module_id
) {
  $data = abas::inspect($module_id)

  $config = $data['config']
  $path = $config['name']
  $module_version = $data['metadata']['Version']

  $setini_version        = 'setini-0.0.0.36'
  $setini_origin         = 'https://registry.abas.sh/artifactory/abas.maven-public/setini/RELEASE'

  $erp_container_name    = $config['erp']['container_name']
  $erp_homedir           = $config['erp']['homedir']
  $clientdir             = $config['client']['clientdir']
  $installation_number   = $config['installation_number']

  $erp_s3_bin_directory = "${erp_homedir}/ow/bin"
  $setini = "${erp_s3_bin_directory}/setini"

  file { "${erp_s3_bin_directory}":
    ensure => 'directory',
  }

  -> exec {"Download setini from the registry" :
    command   => "curl -f -s -L --max-time 1800 ${setini_origin}/${setini_version}.tgz | tar xfz -",
    cwd       => $erp_s3_bin_directory,
    path      => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
    logoutput => true,
  }

  -> exec { 'Transfer ownership of s3 /ow/bin directory to setini':
    command   => "chown --reference ${erp_s3_bin_directory} ${setini}",
    path      => '/bin:/usr/bin',
    logoutput => on_failure,
  }

  if $config['jwt_auth_userinfo'] {
    $jwt_auth_userinfo_url = $config['jwt_auth_userinfo']['jwt_auth_userinfo_url']
  }
  if $config['license_controller'] {
    $license_controller_url = $config['license_controller']['license_controller_url']
  }
  contain client_configuration::server_conf_native
}
