# Configure a client for abas

This module will configure a client (aka mandant) for an abas essentials installation.
It has dependencies to the client and erp it will configure.
And to all modules that provide configuration options.

The dependency to the jwt_auth_userinfo and license_controller module
will create the file `.server.conf` in the client directory.
If it exists it is backed up and overwritten.

## Example

```yaml
  clientConfiguration:
    Host: abas-erp-installation
    Type: abas::client_configuration
    Properties:
      jwt_auth_userinfo: jwtAuthUserinfo
      erp: erp
      client: erp-client
      license_controller: licenseController
```

# The jwt_auth_userinfo dependency

The abas client_configuration module needs a dependency to the jwt_auth_userinfo module.
It uses the `jwt_auth_userinfo_url` output parameter.
This dependency is optional.

# The license_controller dependency

The abas client_configuration module needs a dependency to the license_controller module.
It uses the `license_controller_url` output parameter.
This dependency is optional.
