# abas_client_configuration.rb

module AbasClient_configuration
  class Validation
    def initialize(module_data)
      @config = module_data['resolved_config']
    end

    def validate_installation_number
      installation_number = @config['installation_number']
      license_controller = @config['license_controller']

      if installation_number != nil and license_controller == nil
        license_controller_not_set
      else
        verify_installation_number_value(installation_number)
      end
    end

    def verify_installation_number_value(installation_number)
      return valid if installation_number.nil?

      if installation_number.instance_of? Integer
        valid
      else
        not_a_number(installation_number)
      end
    end

    private

    def valid
      {valid: true}
    end

    def license_controller_not_set
      {valid: false, message: 'cannot set the installation number without knowing the license controller url'}
    end

    def not_a_number(installation_number)
      {valid: false, message: "invalid installation number: `#{installation_number}'; expected a number"}
    end
  end
end