module AbasDashboard
    class Checks < Abas::CheckCollection
      def initialize(data)
        super()
        @factory = CheckFactory.new(data)

        add_pre_install_checks([
          @factory.install_dir_not_exists_check(),
          @factory.disk_space_check(),
          @factory.credential_check(),
          @factory.dashboard_service_port_free_check()
        ])

        add_post_install_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.docker_compose_exists_check()
        ])

        add_runtime_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check()
        ])

        add_pre_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.credential_check()
        ])

        add_post_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
        ])
      end
    end
  end