module AbasDashboard
    require File.join(File.dirname(__FILE__), 'custom/versions')

  class Extras

    def initialize(module_data, credentials_handler)
        @credentials_handler    = credentials_handler
        @config = module_data['resolved_config']
        @host   = module_data['host']
        @product_version = module_data['version']
        @mongodb = @config['mongodb']
        @mongodb_port = @mongodb['mongo_db_port']
        @mongodb_host = @mongodb['hostname']
        @mongodb_dashboard_credentials = @config['mongodb_dashboard_credentials']
    end


    def mongodb_atlas_url
      return "mongodb://#{@credentials_handler.username(@mongodb_dashboard_credentials)}:#{@credentials_handler.password(@mongodb_dashboard_credentials)}@#{@mongodb_host}:#{@mongodb_port}/dashboard"
    end

    def api_version
        return AbasDashboard::Versions.api_version(version: @product_version)
    end

    def ui_version
        return AbasDashboard::Versions.ui_version(version: @product_version)
    end

  end
end
