module AbasDashboard
    require File.join(File.dirname(__FILE__), 'custom/versions')
  class Validation

    def initialize(module_data)
        @config = module_data['resolved_config']
        @host   = module_data['host']
        @product_version = module_data['version']
    end
    
    def version
        if AbasDashboard::Versions.api_version(version: @product_version) == nil
            return {
                :valid => false,
                :message => "Unknown Version"
            }
        else
            return {
                :valid => true,
                :message => "Version is okay"
            }
        end
    end

    def transfer_protocol
        if @config['transfer_protocol'] == 'http' || @config['transfer_protocol'] == 'https'
            return {
                :valid => true,
                :message => "transfer_protocol is okay"
            }
        else
            return {
                :valid => false,
                :message => "transfer_protocol needs to be either http or https"
            }
        end
    end

    def oauth2
        if @config['oauth2'] == nil
            return {
                :valid => false,
                :message => "dashboard module needs outh2 please also configure this module"
            }
        else
            return {
                :valid => true,
                :message => "oauth2 is okay"
            }
        end
    end

    def mongodb
        if @config['mongodb'] == nil
            return {
                :valid => false,
                :message => "dashboard module needs mongodb please also configure this module"
            }
        else
            return {
                :valid => true,
                :message => "mongodb is okay"
            }
        end
    end

    def install_dir
        if @config['install_dir'] == nil
            return {
                :valid => false,
                :message => "please provide a install directory"
            }
        else
            return {
                :valid => true,
                :message => "install_dir is okay"
            }
        end
    end

    def dashboard_api_port
        if @config['dashboard_api_port'] == nil
            return {
                :valid => false,
                :message => "please provide a api port"
            }
        elseif @config['dashboard_api_port'].is_a? Integer == false
            return {
                :valid => false,
                :message => "api port need to be numeric"
            }
        else
            return {
                :valid => true,
                :message => "dashboard_api_port is okay"
            }
        end
    end

    def mongodb_dashboard_credentials
        if @config['mongodb_dashboard_credentials'] == nil
            return {
                :valid => false,
                :message => "please provide mongodb_dashboard_credentials"
            }
        else
            return {
                :valid => true,
                :message => "mongodb_dashboard_credentials is okay"
            }
        end
    end

    def registry_credentials
        if @config['registry_credentials'] == nil
            return {
                :valid => false,
                :message => "please provide registry_credentials"
            }
        else
            return {
                :valid => true,
                :message => "registry_credentials is okay"
            }
        end
    end

    def user
        if @config['user'] == nil
            return {
                :valid => false,
                :message => "please provide user"
            }
        else
            return {
                :valid => true,
                :message => "user is okay"
            }
        end
    end
  end
end
