module AbasEdp

  project_dir = File.expand_path("..", File.dirname(__FILE__))
  require File.join(project_dir, 'checks/edp_connection_check')

  class CheckFactory

    def initialize(data)
      @config = data['config']
    end

    def port_used_check()
      Abas::PortCheck.create(name: "Check if edp port is in use", port: @config['port'], free: false)
    end

    def edp_connection_check()
      AbasEdp::EdpConnectionCheck.create(
        name: "Check if edp connection can be established",
	      port: @config['port']
      )
    end

  end
end