# abas_edp.rb

module AbasEdp
  class Main
    def initialize(id_hash)
      @service_name = id_hash['service_name']
      @dockerized = id_hash['dockerized']
      @container_name = id_hash['container_name']

      @config_file = File.join(servicefile_path(), @service_name)
    end

    def exists?
      if @dockerized
        result = system("docker exec -t #{@container_name} ls #{@config_file} > /dev/null 2> /dev/null")
        if result
          @filecontent = `docker exec -t #{@container_name} cat #{@config_file}`
        end
        return result
      else
        result = File.file? @config_file
        if result
          @filecontent = File.read @config_file
        end
        return result
      end
    end

    def port
      if @dockerized
        `docker port #{@container_name} 6550`.split(":")[1]
      else
        @filecontent.match(/port(.*)=(.*)/)[2].strip
      end
    end

    def hostname
      if @dockerized
        if (`docker inspect -f {{.State.Running}} #{@container_name}`.strip == 'true')
          return `hostname`.strip
        else
          return ''
        end
      else
        if File.file? (File.join(servicefile_path(), @service_name))
          return `hostname`.strip
        else
          return ''
        end
      end
    end

    def servicefile_path
      if @dockerized
        path_config = `docker exec -u 0 -t #{@container_name} grep '^includedir' /etc/xinetd.conf`
      else
        path_config = `grep '^includedir' /etc/xinetd.conf`
      end

      path = path_config.split(' ').last.strip
      path = path.concat("/") unless path.end_with? "/"

      return path
    end


    def erp
      Erp.new(@filecontent)
    end
  end

  class Erp
    def initialize(filecontent)
      @filecontent = filecontent
    end

    def homedir
      @filecontent.match(/server(.*)=(.*)/)[2].strip
    end
  end
end
