module AbasErp
    class ServiceProperties
    
        attr_reader :service_name
    
        def initialize(file)
        @file = file
        @raw = ""
        @data = Hash.new
        @service_name = ""
        @valid = true
    
        begin
            @raw = File.read(@file)
        rescue StandardError => e
            @valid = false
        end
    
        parse_file
        end
    
        def valid?
        return @valid
        end
    
        def value(key)
        @data[key].strip
        end
    
        def key?(key)
        @data.key? key
        end
    
        private 
    
        def parse_file
        @raw.each_line do |line|
            line = line.partition("#")[0].strip
            
            if line.start_with?("service")
            @service_name = line.split(" ").last.strip
            next
            elsif line.start_with?("{") || line.start_with?("}")
            next
            end
    
            result = line.partition("=")
            if result[1] == "="
            @data[result[0].strip] = result[2].strip
            end
        end
    
        rescue StandardError
        @valid  = false
        end
    
    end
end