module AbasErp
  class Outputs

    def initialize(module_data)
      @config  = module_data['config']
      @host    = module_data['host']
      @version = @config['version']
      @myVersion = Abas::Version.new(@version)
    end

    def ip  
      return @host['Properties']['ip']
    end

    def hostname
      return @host['Properties']['hostname']
    end

    def container_name
      return @config['container_name']
    end

    def homebase
      homedir = @config['homedir']
      s3_dir = homedir.split("/").last
      homebase = homedir.sub(s3_dir, "")
      # delete / at end
      homebase.slice!(-1) if homebase[-1] == "/"
      return homebase
    end

    def version_year
      return @myVersion.year
    end

    def dockerized
      return false
    end
    def container_name
      return 'no_longer_supported'
    end
  end
end
