module AbasEsdk_app
    class Extras
        def initialize(module_data, credentials_handler)
            @credentials_handler    = credentials_handler
            @configuration          = module_data['resolved_config']
            @host                   = module_data['host']
        end

        def installer_arguments
            maven_repo_user = @credentials_handler.username(@configuration['registry_credentials'])
            maven_repo_password = @credentials_handler.password(@configuration['registry_credentials'])

            edp_user = @credentials_handler.username(@configuration['edp_credentials'])
            edp_password = @credentials_handler.password(@configuration['edp_credentials'])

            result = ""
            result += " -a #{@configuration['artifact_url']}"
            result += " --maven-repo-user #{maven_repo_user}"
            result += " --maven-repo-password #{maven_repo_password}"
            result += " --edp-user #{edp_user}" if (edp_user && edp_user != "")
            result += " --edp-password #{edp_password}"
            result += " --yes-i-have-a-backup"
            result += " --skip" if @configuration['skip_eapps']
            result += " --eapps-only" if @configuration['eapps_only']
            result += " --force" if @configuration['force']
            result += " --skip-essentials-versioncheck" if @configuration['skip_essentials_versioncheck']

            return result
        end
    end
end
