define esdk_app::install_native($data) {
  $installer_arguments  = $data['extras']['installer_arguments']


  $installer_version    = $data['config']['installer_version']
  $installer_zip        = "esdk-app-installer-${installer_version}.zip"

  $homedir                     = $data['config']['erp']['homedir']
  $clientdir                   = $data['config']['client']['clientdir']
  $client_user                 = $data['config']['client_user']
  $s3_user                     = $data['config']['erp']['s3_user']
  $timeout                     = $data['config']['timeout']
  $s3lock                      = $data['config']['s3lock']

  if !defined('$timeout') {
    $timeout = 0
  }

  if($s3lock == true) {
    $s3lock_value = "trotz_s3lock=1 "
  } else {
    $s3lock_value = ""
  }

  file { '/tmp/installer_version.txt':
    ensure  => file,
    content => "${installer_version}"
  }

  -> exec {'Download esdk app installer':
    command => "curl -Lo ${installer_zip} https://registry.abas.sh/artifactory/abas.maven-public/de/abas/esdk/installer/${installer_version}/installer-${installer_version}.zip",
    cwd     => '/tmp',
    creates => "${homedir}/esdk-app-installer/esdk-app-installer-${installer_version}",
    path    => '/usr/bin',
  }
  -> exec { 'Unzip esdk app installer':
    command => "unzip ${installer_zip} -d ${homedir}/esdk-app-installer",
    creates => "${homedir}/esdk-app-installer/esdk-app-installer-${installer_version}",
    cwd     => '/tmp',
    path    => '/usr/bin',
  }
  -> exec { 'chown installer':
    command => "chown -R ${s3_user} ${homedir}/esdk-app-installer/esdk-app-installer-${installer_version}",
    logoutput => true,
    path    => ['/usr/sbin', '/bin'],
  }
  -> exec { 'install esdk app':
    command   => "eval $(sh denv.sh) && ${s3lock_value}${homedir}/esdk-app-installer/esdk-app-installer-${installer_version}/bin/esdk-app-installer ${installer_arguments}",
    cwd       => "${clientdir}",
    logoutput => true,
    user      => "${client_user}",
    path      => "/usr/bin:/usr/sbin:/bin",
    provider  => "shell",
    timeout   => $timeout,
  }

}

