# abas_fulltext_search.rb
require 'json' # import
require 'socket'

module AbasFulltext_search
  class Main
    def initialize(id_hash)
      @install_dir = id_hash['install_dir']
    end

    def exists?
        return (File.file?(File.join(@install_dir, "/installed.json")) \
        and File.file?(File.join(@install_dir, "/install-on-premise.sh")))
    end

    def search_engine_port
        obj = JsonUtil.read_json(@install_dir, 'installed.json')
        port = obj["port"]
        begin
          s = TCPSocket.new("localhost", port)
          s.close
          return port
        rescue Errno::ECONNREFUSED, Errno::EHOSTUNREACH
          return -1
        end
    end

  end

  class JsonUtil
    def self.read_json(install_dir, filename)
        file_path = File.join(install_dir, filename)
        if File.exist?(file_path)
          file = File.open(file_path)
          return JSON.parse(file.read)
        else
          return JSON.parse('{}')
        end 
        
    end
  end
end