#!/bin/bash
if [ -z "$ERP_CLIENT" ]; then
  echo "No erp client defined in env variable ERP_CLIENT."
fi
cd $ERP_CLIENT
eval $(sh ./denv.sh)
NOBACKUP_HOMEDIR=$(envmake -m $HOMEDIR -q NOBACKUP)
CLOUDDIR="$NOBACKUP_HOMEDIR/cloudsearch"
CLOUDMANDDIR="$CLOUDDIR/$MNAME"
DISABLED_MARKER="$CLOUDMANDDIR/disabled"
JETTY_BASE=$CLOUDMANDDIR/jetty
CONFIGDIR=$CLOUDMANDDIR/config
INDEXDIR=$CLOUDMANDDIR/index
DATABASEDIR=$INDEXDIR/$index
DATADIR=$DATABASEDIR/increxport
LUCENEDIR=$DATABASEDIR/lucene
COMMITFILE=$DATABASEDIR/lastcommit
DIC_DATADIR=$INDEXDIR/dictionary
QUICK_DATADIR=$INDEXDIR/quicksearch
PORT_FILE="$CLOUDMANDDIR/fts-cloudsearch.port"
if [ -s "$PORT_FILE" ]; then
  PORT=$(cat $PORT_FILE)
fi

function fts_is_disabled() {
  if [ -e "$DISABLED_MARKER" ]; then
    echo "Search engine and index updates for $ERP_CLIENT are DISABLED."
    return 0
  fi
  return 1
}

function disable_fts() {
  [ -e "$DISABLED_MARKER" ] || touch "$DISABLED_MARKER"
}
