class fulltext_search (String $module_id) {

  $config = abas::inspect($module_id)['config']

  $install_dir = $config['install_dir']
  $client_dir = $config['client']['clientdir']
  $client_id = $config['client']['ai_identifier']
  $jetty_port= $config['search_engine_port']
  $s3_user = $config['erp']['s3_user']
  $fts_version = $config['version']

  exec { "create install dir":
    command => "mkdir -p $install_dir",
    path    => "/bin",
  }
  # copy all the scripts into install dir
  -> file { "${install_dir}/fts":
    ensure  => directory,
    recurse => true,
    source  => ["puppet:///modules/fulltext_search/fts"]
  }
  -> file { "${install_dir}/version":
    ensure  => file,
    content => template("fulltext_search/version.erb"),
  }
  -> file { "${install_dir}/install-on-premise.sh":
    ensure  => file,
    content => template("fulltext_search/install-on-premise.sh.erb"),
  }
  -> file { "${install_dir}/up.sh":
    ensure  => file,
    content => template("fulltext_search/up.erb"),
  }
  -> file { "${install_dir}/down.sh":
    ensure  => file,
    content => template("fulltext_search/down.erb"),
  }
  -> exec { "check preconditions":
    command => "bash ./fts/checkPreconditions.sh",
    cwd     => $install_dir,
    path    => "/bin:/usr/bin"
  }
  -> exec { "install in erp":
      command => "bash install-on-premise.sh",
      cwd     => $install_dir,
      path    => "/bin:/usr/bin",
  }
  -> file { "${install_dir}/installed.json":
    ensure  => file,
    content => template("fulltext_search/installed.json.erb"),
  }
}
