module AbasKeycloak
  class CheckFactory

    def initialize(data)
        @config = data['config']
    end

    def http_port_free_check()
      Abas::PortCheck.create(name: "Check if http port for Keycloak is free", port: @config['http_port'], free: true)
    end

    def http_port_used_check()
      Abas::PortCheck.create(name: "Check if http port for Keycloak is used", port: @config['http_port'], free: false)
    end

    def https_port_free_check()
      Abas::PortCheck.create(name: "Check if https port for Keycloak is free", port: @config['https_port'], free: true)
    end

    def https_port_used_check()
      Abas::PortCheck.create(name: "Check if https port for Keycloak is used", port: @config['https_port'], free: false)
    end

    def management_http_port_free_check()
      Abas::PortCheck.create(name: "Check if management http port for Jboss Server running Keycloak is free", port: @config['management_http_port'], free: true)
    end

    def management_http_port_used_check()
      Abas::PortCheck.create(name: "Check if management http port for Jboss Server running Keycloak is used", port: @config['management_http_port'], free: false)
    end

    def install_dir_exists_check()
      Abas::FileCheck.create(name: "Check if install_dir exists", path: @config['install_dir'], should_exist: true)
    end

    def install_dir_not_exists_check()
      Abas::FileCheck.create(name: "Check if install_dir does not exist", path: @config['install_dir'], should_exist: false)
    end
  end

end
