module AbasKeycloak
  class Checks < Abas::CheckCollection

    def initialize(data)
      super()
      @config = data['config']
      @factory = CheckFactory.new(data)

      add_pre_install_checks([
        @factory.install_dir_not_exists_check(),
        @factory.http_port_free_check(),
        @factory.https_port_free_check()
      ])
      
      if !(@config['management_http_port'].nil?)
        add_pre_install_checks([
          @factory.management_http_port_free_check()
        ])
      end

      add_post_install_checks([
        @factory.install_dir_exists_check(),
        @factory.http_port_used_check(),
        @factory.https_port_used_check(),
      ])            

      if !(@config['management_http_port'].nil?)
        add_post_install_checks([
          @factory.management_http_port_used_check()
        ])
      end

      add_runtime_checks([
        @factory.install_dir_exists_check()
      ])

      add_pre_update_checks([
        @factory.install_dir_exists_check()
      ])

      add_post_update_checks([
        @factory.install_dir_exists_check()
      ])
    end
  end
end
