require File.join(File.dirname(__FILE__), 'constants')

module AbasKeycloak
    class DerivedConstants
        attr_reader :baseUrl, :master_realm_endpoint, :baseOpenIDC, :issuer_realm, :wellKnownBase

        def initialize(config: , host: )
            @config       = config
            @host         = host
            @secure_mode = @config['secure_mode']
            if @secure_mode then
                @scheme = 'https'
                @scheme_port = @config['https_port']
            else
                @scheme = 'http'
                @scheme_port = @config['http_port']
            end
            @realm = @config['realm']
            @master_realm = @config['master_realm']
            @baseUrl = "#{@scheme}://#{@host["Properties"]["hostname"]}:#{@scheme_port}"
            @master_realm_endpoint =  baseUrl + "/auth/realms/#{@master_realm}"
            @baseOpenIDC = "/auth/realms/#{@realm}/protocol/openid-connect"
            @wellKnownBase = "/auth/realms/#{@realm}/.well-known"
            @issuer_realm = "/auth/realms/#{@realm}"
        end
    end
end