# abas_keycloak.rb
require 'yaml' # import
require File.join(File.dirname(__FILE__), '..', 'constants')

module AbasKeycloak
  class AbasKeycloakService

    RUNNING = :running
    STOPPED = :stopped
    MISSING = :missing
    FAILURE = :failure

    def initialize(resolved_config)
        @resolved_config = resolved_config
        @install_dir = resolved_config['install_dir']
    end

    def exists?
        return File.file?(File.join(@install_dir, "/docker-compose.yml"))
    end

    def status
      if exists?
        result1 = system("cd #{@install_dir} && docker ps -q --no-trunc --filter status=running | grep -q $(docker-compose ps -q #{Constants::DOCKER_COMPOSE_KEYCLOAK_SERVICE_NAME})")
        result2 = system("cd #{@install_dir} && docker ps -q --no-trunc --filter status=running | grep -q $(docker-compose ps -q #{Constants::DOCKER_COMPOSE_KEYCLOAK_POSTGRES_SERVICE_NAME})")
        if ( result1 && result2 )
          return RUNNING
        elsif ( !result1 && !result2 )
          return STOPPED
        else
          return FAILURE
        end
      end
    end

    def start
      `cd #{@install_dir} && ./service.sh --up -- --force-recreate`
    end

    def stop
      `cd #{@install_dir} && ./service.sh --down`
    end
  end
end