# The keycloak manifest file.
class keycloak(String $module_id) {

  $data = abas::inspect($module_id)
  $install_dir = $data['config']['install_dir']
  $needed_packages = [ 'bash' ]
  $user = $data['config']['user']

  package { $needed_packages:
    ensure => 'present',
  }
  -> user { "Creating ${user}":
    ensure     => 'present',
    name       => $user,
    managehome => true,
    groups     => ['docker'],
  }
  -> exec {'Creating installation directory':
    command => "mkdir -p ${install_dir} && chown ${user} ${install_dir}",
    onlyif  => "test ! -d ${install_dir}",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> keycloak::install_keycloak { 'Install Keycloak':
    data    => $data,
    command => "INSTALL",
  }
}
