# Keycloak update class
class keycloak::update(String $module_id) {

  $data               = abas::inspect($module_id)
  $config             = $data['config']
  $install_dir        = $config['install_dir']
  $user               = $config['user']

  exec { 'DOCKER: Stop and remove containers':
    command => 'docker-compose down || :',
    cwd     => $install_dir,
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
    user    => $user,
  }
  -> keycloak::update_revision_164 { 'Steps to update from Revision 164':
    data    => $data,
  }
  -> keycloak::install_keycloak { 'Install Keycloak':
    data    => $data,
    command => "UPDATE",
  }
}
