# Released Revision 164 had a different directory structure. 
# Fix and delete unneeded files. 
define keycloak::update_revision_164($data) {

  $install_dir          = $data['config']['install_dir']
  $docker_dir           = "${install_dir}/docker"
  $certificates_dir     = "${install_dir}/certificates"
  $old_certificates_dir = "${install_dir}/docker/certificates"
  $bin_dir              = "${install_dir}/bin"

  exec {'Move the certificates directory to install directory':
    command => "mv ${old_certificates_dir} ${certificates_dir}",
    onlyif  => "test -d ${old_certificates_dir}",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> exec {'Remove uneeded docker directory':
    command => "rm -rf ${docker_dir}",
    onlyif  => "test -d ${docker_dir}",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> exec {'Removed renamed update-content-security-poliy.sh file':
    command => "rm ${bin_dir}/update-content-security-poliy.sh",
    onlyif  => "test -f ${bin_dir}/update-content-security-poliy.sh",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> exec {'Removed unneeded is_alive.sh file':
    command => "rm ${bin_dir}/is_alive.sh",
    onlyif  => "test -f ${bin_dir}/is_alive.sh",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
}
