# abas_keycloak.rb

#- Name: port
#- Name: issuer
#- Name: jwksUrl
#- Name: userInfoEndpoint
#- Name: oidc_configuration_url

require File.join(File.dirname(__FILE__), 'derived_constants')

module AbasKeycloak
  class Outputs

    def initialize(module_data)
        @config = module_data['config']
        @host   = module_data['host']

        @DerivedConstants = AbasKeycloak::DerivedConstants.new(config: @config, host: @host).freeze
    end

    def issuer
      return @DerivedConstants.baseUrl + @DerivedConstants.issuer_realm
    end

    def jwks_url
      return @DerivedConstants.baseUrl + @DerivedConstants.baseOpenIDC + "/certs"
    end

    def user_info_endpoint
      return @DerivedConstants.baseUrl + @DerivedConstants.baseOpenIDC + "/userinfo"
    end

    def oidc_configuration_url
      return @DerivedConstants.baseUrl + @DerivedConstants.wellKnownBase + "/openid-configuration"
    end

    def audience
      return @config['audience']
    end

    def host_ip
      return @host["Properties"]["ip"]
    end

    def base_url
      return @DerivedConstants.baseUrl
    end

    def realm
      return @config['realm']
    end
  end
end
