# The Jboss Keycloak module for abas

This module will install the Open source Redhat product Keycloak and configure it for abas clients to work.

A minimun definition might look like this:

```yaml
  keycloak:
    Type: abas::keycloak
    Host: main
    Properties:
      install_dir: /opt/abas/keycloak
      user: yourUser
      project_name: pre-install-test
      keycloak_admin_credentials: keycloak_admin_credentials
      webserver_base_url: webserver.webserver_base_url
      realm: abas
      audience: erp
      keycloak_db_credentials: keycloak_db_credentials   
      
  Credentials: 
    keycloak_admin_credentials:
      username: admin
      password: admin   
    keycloak_db_credentials:
      username: keycloak
      password: keycloak       
```

The a more comprehensive abasfile entry for this module can look like this for development/testing purposes:

```yaml
  keycloak:
    Type: abas::keycloak
    Host: main
    Properties:
      install_dir: /opt/keycloak
      user: yourUser
      project_name: pre-install-test
      realm: abas
      audience: erp
      overwrite_realm: false
      http_port: 9090
      https_port: 9091
      management_http_port: 9990
      keycloak_loglevel: DEBUG
      root_loglevel: INFO
      secure_mode: false
      keycloak_admin_credentials: keycloak_admin_credentials
      webserver_base_url: webserver.webserver_base_url
      keycloak_db_credentials: keycloak_db_credentials   
  Credentials: 
    keycloak_admin_credentials:
      username: admin
      password: admin      
    keycloak_db_credentials:
      username: keycloak
      password: keycloak   
```
# The Module References

The Abas Keycloak module needs a reference to the abas:webserver output parameter. This is needed to do various security header configurations in keycloak.
In the example snippet above the string value "webserver.webserver_base_url", the first part denotes the name of your webserver module in the abasfile.
The part after the dot is the output parameter defined on the abas:webserver module.


## The Jboss Keycloak default input parameters

The default ports feature is being turned off. All Ports have to be provided manually.

The following are optional input parameters and can be excluded and resonable defaults are provided.

* "http_port" has a default value of 80
* "https_port" has a default value of 443
* "keycloak_loglevel" has a default value of INFO
* "root_loglevel" has a default value of INFO
* "secure_mode" has a default value of false