module AbasLicense_controller
  class CheckFactory

    def initialize(data)
        @config = data['config']
    end

    def service_port_free_check()
        Abas::PortCheck.create(name: "Check if service port is free", port: @config['port'], free: true)
    end

    def install_dir_exists_check()
      Abas::FileCheck.create(name: "Check if install_dir exists", path: @config['install_dir'], should_exist: true)
    end

    def service_running_check()
      Abas::DockerComposeServiceRunningCheck.create(
          name: "Check if the license controller service is running",
          project_name: @config['project_name'],
          service_name: "abas-license-controller"
      )
    end

  end

end
