require File.join(File.dirname(__FILE__), 'constants')
require File.join(File.dirname(__FILE__), 'derived_constants')

module AbasMongodb
  class Extras

    attr_reader :mongodb_initd_dir, :mongodb_db_dir, :docker_compose_mongodb_service_name, :docker_compose_mongodb_exp_service_name,
                :container_mongodb_initd_dir

    def initialize(module_data, credentials_handler)
        @credentials_handler    = credentials_handler
        @config = module_data['resolved_config']
        @host   = module_data['host']
        @databases = @config['databases']
        @docker_compose_mongodb_service_name          = AbasMongodb::Constants::DOCKER_COMPOSE_MONGODB_SERVICE_NAME
        @docker_compose_mongodb_exp_service_name          = AbasMongodb::Constants::DOCKER_COMPOSE_MONGODB_EXP_SERVICE_NAME
        @container_mongodb_initd_dir = AbasMongodb::Constants::CONTAINER_MONGODB_INITD_DIR
        @DerivedConstants   = AbasMongodb::DerivedConstants.new(install_dir: @config['install_dir'], project_name: @config['project_name'] )
        @mongodb_initd_dir  = @DerivedConstants.MONGODB_INITD_DIR
        @mongodb_db_dir     = @DerivedConstants.MONGODB_DB_DIR
    end

    def databases_resolved
      databases_resolved = Hash.new
      @databases.each do |database_key,database_value|     
        database_username = @credentials_handler.username(database_value['credentials'])
        database_password = @credentials_handler.password(database_value['credentials'])
        if database_username != nil
          database = {
            'database_name' => database_key,
            'username' => database_username,
            'password' => database_password
          }
          databases_resolved.merge!( database_key => database)
        end
      end
      return databases_resolved
    end

  end
end