# abas_mongodb_service.rb
require File.join(File.dirname(__FILE__), '../', 'derived_constants')
require File.join(File.dirname(__FILE__), '../', 'constants')

module AbasMongodb
  class AbasMongodbService

    RUNNING = :running
    STOPPED = :stopped
    MISSING = :missing
    FAILURE = :failure

    def initialize(resolved_config)
        @resolved_config = resolved_config
        @install_dir = resolved_config['install_dir']
        @install_mongoexpress = resolved_config['install_mongoexpress']
        @DerivedConstants = AbasMongodb::DerivedConstants.new(install_dir: @install_dir, 
                                                              project_name: resolved_config['project_name']).freeze        
    end

    def exists?
        return File.file?(File.join(@install_dir , "docker-compose.yml"))
    end

    def status
      if exists?
        result1 = system("cd #{@DerivedConstants.DOCKER_COMPOSE_DIR} && docker ps -q --no-trunc --filter status=running | grep $(docker-compose ps -q #{@AbasMongodb::Constants::DOCKER_COMPOSE_MONGODB_SERVICE_NAME})")
        if (@install_mongoexpress) 
          result2 = system("cd #{@DerivedConstants.DOCKER_COMPOSE_DIR} && docker ps -q --no-trunc --filter status=running | grep $(docker-compose ps -q #{@AbasMongodb::Constants::DOCKER_COMPOSE_MONGODB_EXP_SERVICE_NAME})")
          if ( result1 && result2 )
            return RUNNING
          elsif ( !result1 && !result2 ) 
            return STOPPED
          else
            return FAILURE
          end
        else
          if (result1) 
            return RUNNING
          else
            return STOPPED
          end
        end
      end
    end

    def start
      `cd #{@install_dir} && docker-compose up -d --force-recreate`
    end

    def stop
      `cd #{@install_dir} && docker-compose down`
    end
  end
end