# abas_oauth2.rb

module AbasOauth2
  class Outputs

    def initialize(module_data)
        @log = AbasLogger.instance
        @config = module_data['config']
        @host   = module_data['host']
        if @config['type'] == 'auth0' && @config['auth0'] != nil
          @log.debug("Detected auth0 module")
          @oauthImpl = @config['auth0']
        elsif @config['type'] == 'keycloak' && @config['keycloak'] != nil
          @log.debug("Detected keycloak module")
          @oauthImpl = @config['keycloak']
          # Only keycloak module has realms
          @keycloak_realm = @oauthImpl.resolve('realm')
        else
          raise ArgumentError, 'Unknown auth module. Type and module have to match.'
        end
        @issuer = @oauthImpl.resolve('issuer')
        @oidc_configuration_url = @oauthImpl.resolve('oidc_configuration_url')
        @jwks_url = @oauthImpl.resolve('jwks_url')
        @user_info_endpoint = @oauthImpl.resolve('user_info_endpoint')
        @audience = @oauthImpl.resolve('audience')
        @base_url = @oauthImpl.resolve('base_url')
    end

    def type
      return @type
    end

    def issuer 
      return @issuer || ''
    end

    def jwks_url
      return @jwks_url || ''
    end

    def user_info_endpoint
      return @user_info_endpoint || ''
    end

    def audience
      return @audience || ''
    end

    def base_url
      return @base_url || ''
    end

    def keycloak_realm
      return @keycloak_realm || ''
    end

    def oidc_configuration_url
      return @oidc_configuration_url || ''
    end
  end
end