# abas_oauth2.rb

module AbasOauth2
  class Validation

    def initialize(module_data)
        @log = AbasLogger.instance

        @config = module_data['resolved_config']
        @host   = module_data['host']
    end

    def check_dependencies
      result = Hash.new
      result[:valid] = true

      if @config['type'] == 'auth0' && @config['auth0'] == nil
        result[:valid] = false
        result[:message] = "The selected type is 'auth0'. Please provide a parameter 'auth0' with a abas::auth0 module dependency!" 
      end

      if @config['type'] == 'auth0' && @config['keycloak'] != nil
        result[:valid] = false
        result[:message] = "The selected type is 'auth0'. Please remove the parameter 'keycloak'." 
      end

      if @config['type'] == 'keycloak' && @config['keycloak'] == nil
        result[:valid] = false
        result[:message] = "The selected type is 'keycloak'. Please provide a parameter 'keycloak' with a abas::keycloak module dependency!" 
      end

      if @config['type'] == 'keycloak' && @config['auth0'] != nil
        result[:valid] = false
        result[:message] = "The selected type is 'keycloak'. Please remove the parameter 'auth0'." 
      end

      return result
    end

  end
end