module AbasRest_api
  class Checks < Abas::CheckCollection

    def initialize(data)
      super()
      @factory = CheckFactory.new(data)

      add_pre_install_checks([
        @factory.install_dir_not_exists_check(),
        @factory.service_port_free_check()
      ])

      add_post_install_checks([
        @factory.install_dir_exists_check()
      ])

      add_runtime_checks([
        @factory.install_dir_exists_check(),
        @factory.service_running_check()
      ])

      add_pre_update_checks([
        @factory.install_dir_exists_check()
      ])

      add_post_update_checks([
        @factory.install_dir_exists_check()
      ])
    end
  end
end
