module AbasRest_api
  class Extras

    def initialize(module_data)
      @config = module_data['resolved_config']
      @host   = module_data['host']
    end

    def oauth2_audience
      if @config['oauth2'] == nil
        return nil
      end
      return "#{@config['oauth2']['audience']}"
    end
    
    def oauth2_jwks_uri
      jwks_url = @config.dig('oauth2', 'jwks_url')
      return jwks_url
    end

    def oauth2_issuers
      issuers = @config.dig('oauth2', 'issuer')
      return issuers
    end

    def port
      if @config['port'] == 0
        ""
      else
        @config['port']
      end
    end

    private

    def docker_command
      []
    end
  end
end
