define rest_api::erp_connections($clients, $install_dir, $user) {
  $clients.each |Hash $client| {

    $client_id = $client['id'] ? {
      ''      => $client['client']['mname'],
      undef   => $client['client']['mname'],
      default => $client['id'],
    }

    $description = $client['description'] ? {
      ''      => $client['client']['mandant'],
      undef   => $client['client']['mandant'],
      default => $client['description'],
    }

    $client_identifier = $client['client']['ai_identifier']

    rest_api::erp_connection { "${install_dir}/abasconfig/erp.connection-${client_id}.cfg":
      owner                                => $user,
      id                                   => $client_id,
      description                          => $description,
      host                                 => $client['edp']['hostname'],
      port                                 => $client['edp']['port'],
      client                               => $client['client']['clientdir'],
      min_pool_size                        => $client['min_pool_size'],
      max_pool_size                        => $client['max_pool_size'],
      max_pool_idle                        => $client['max_pool_idle'],
      max_pool_wait                        => $client['max_pool_wait'],
      disable_pool                         => $client['disable_pool'],
      ws_timeout_minutes                   => $client['ws_timeout_minutes'],
      initialize_meta_data_on_startup      => $client['initialize_meta_data_on_startup'],
      time_between_two_pool_controls       => $client['time_between_two_pool_controls'],
      max_ftext_size                       => $client['max_ftext_size'],
      metadata_polling_interval_in_seconds => $client['metadata_polling_interval_in_seconds'],
      edp_log_cache_size                   => $client['edp_log_cache_size'],
      force_edp_client_version             => $client['force_edp_client_version'],
    }
  }  
}
