class rest_api(String $module_id) {

  $data = abas::inspect($module_id)
  $config         = $data['config']
  $install_dir    = $config['install_dir']
  $user           = $config['user']

  user { $user:
    ensure     => 'present',
    managehome => true,
    groups     => ['docker'],
  }
  -> exec { "recursively create ${install_dir}":
    command => "mkdir -p ${install_dir}",
    onlyif  => "test ! -d ${install_dir}",
    path    => '/usr/bin:/bin',
  }
  -> file { $install_dir:
    ensure  => directory,
    owner   => $user,
    recurse => true,
  }
  -> file { "${install_dir}/abasconfig":
    ensure => directory,
    owner  => $user,
  }
  -> file { "${install_dir}/data":
    ensure => directory,
    owner  => $user,
  }
  -> file { "${install_dir}/log":
    ensure => directory,
    owner  => $user,
  }
  -> rest_api::install { 'Install rest_api container':
    data    => $data,
  }

}
