require "base64"
require "json"

module AbasTenant_identity
  class Outputs

    def initialize(module_data)
        @config = module_data['config']
        @host   = module_data['host']
        @tenantConfig = decode_json("#{@config["b64_configuration_string"]}")
    end

    def tenant
      return @tenantConfig["tenant"]
    end

    def tenant_id
      return @tenantConfig["tenant_id"]
    end

    def domain
      return @tenantConfig["domain"]
    end

    def aws_access_key_id
      return @tenantConfig["aws_access_key_id"]
    end

    def aws_secret_access_key
      return @tenantConfig["aws_secret_access_key"]
    end

    def aws_region
      return @tenantConfig["aws_region"]
    end

    def stage
      return @tenantConfig["stage"]
    end

    private # private methods start here
    def decode_json(b64_string)
      plain_string = Base64.decode64(b64_string)
      return JSON.parse(plain_string)
    end

  end
end