require "base64"
require "json"

module AbasTenant_identity
  class Validation

    def initialize(module_data)
        @log = AbasLogger.instance
        @config = module_data['resolved_config']
        @host   = module_data['host']
    end

    def is_base64_json
      begin
        @log.debug("Base64 decode configuration string")
        b64_string = @config["b64_configuration_string"]
        plain_string = Base64.decode64(b64_string)
        @log.debug("Parsing configuration json string")
        json = JSON.parse(plain_string)
        return {
          :valid => true
        }
      rescue => e
        @log.error(e.backtrace.join("\n"))
        return {
          :valid => false,
          :message => e.message
        }
      end
    end

  end
end