# abas_user_administration.rb

module AbasUser_administration
  class AbasUserAdministrationService
    RUNNING = :running
    STOPPED = :stopped
    MISSING = :missing
    FAILURE = :failure

    def initialize(resolved_config)
      @resolved_config = resolved_config
      @install_dir = resolved_config['install_dir']
    end

    def exists?()
      if ( File.file?(File.join(@install_dir, "/service.sh"))  &&
          File.file?(File.join(@install_dir, "/VERSION")) &&
          File.file?(File.join(@install_dir, "/docker-compose.yml")) &&
          File.file?(File.join(@install_dir, "/service-defaults.env")) )
        return true
      end
      return false
    end

    def status
      return MISSING unless exists?

      existing_containers = `cd #{@install_dir} && ./service.sh --status -- -q`
      existing_containers_succeeded = $?.success?

      unless existing_containers_succeeded
        return FAILURE
      end

      if existing_containers.strip.empty?
        return STOPPED
      end

      is_running = system("cd #{@install_dir} && docker ps -q --no-trunc --filter status=running | grep -q $(./service.sh --status -- -q)")

      if is_running
        RUNNING
      else
        FAILURE
      end
    end

    def start
      `cd #{@install_dir} && ./service.sh --up`
    end

    def stop
      `cd #{@install_dir} && ./service.sh --down`
    end
  end
end
