# Main install manifest user_administration service 
class user_administration(String $module_id) {

  $data = abas::inspect($module_id)

  $config                = $data['config']
  $install_dir           = $config['install_dir']
  $user                  = $config['user']

  user { $user:
    ensure     => 'present',
    managehome => true,
    groups     => ['docker'],
  }

  -> exec { "recursively create ${install_dir}":
    command => "mkdir -p ${install_dir}",
    path    => '/usr/bin:/bin',
    user    => 'root',
  }

  -> exec { 'Change ownership of install directory':
    command => "chown -R ${user} ${install_dir}",
    path    => '/usr/bin:/bin:/usr/local/bin',
    cwd     => $install_dir,
  }

  -> user_administration::install_templates_and_run { 'install_templates_and_run user_administration':
      data    => $data,
  }

}
