# The abas webclient module

## Development

### abasfile for module development

Please make sure to put a `credentials.yml` file inside the directory where your `abasfile.yml` is located.
Look into the abas-installer documentation to get further information about this.

### abasfile for module development


```
  webclient:
    Host: main
    Type: abas::webclient
    Properties:
      install_dir: /opt/webclient
      version: 2.8.0-beta_build-5401
      registry_credentials: registry_credentials # reference to credentials containing username and password
      rest_api: mw # name of the rest-api module (section), aka. mw
```

### abasfile section for screen-fetcher

For the Webclient it is necessary to install the screen-fetcher ESDK app.

```
  screenfetcher:
    Type: abas::esdk_app
    Host: main
    Properties:
      erp: erp
      app_id: scrfr
      installer_version: 0.12.1
      app_version: 1.9.6
      client: erp-client
      client_user: erp
      artifact_url: "https://registry.abas.sh/artifactory/abas.maven-public/cloud/abas/screenservice/screen-fetcher/1.9.6/screen-fetcher-1.9.6.jar"
      registry_credentials: registry_credentials
      edp_credentials: edp_credentials
      skip_eapps: false
```

Optional parameters are `ucm_srv_port`, `screen_srv_port`, `prefs_srv_port` and `activity_srv_port`.

### Debugging

sudo su -c "source /etc/profile && puppet apply --detailed-exitcodes --modulepath=/opt/abas-installer-workdir/modules/abas:/opt/abas-inspect/puppet/modules:/etc/puppetlabs/code/environments/production/modules -e \"class { 'webclient': module_id => 'webclient'}\""
