module AbasWebclient
    class Checks < Abas::CheckCollection
  
      def initialize(data)
        super()
        @factory = CheckFactory.new(data)

        add_pre_install_checks([
          @factory.install_dir_not_exists_check(),
          @factory.disk_space_check(),
          @factory.credential_check(),
          @factory.screen_service_port_free_check(),
          @factory.menu_service_port_free_check(),
          @factory.activitiy_service_port_free_check(),
        ])

        add_post_install_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.config_menu_service_exists_check(),
          @factory.config_screen_service_exists_check(),
          @factory.docker_compose_exists_check(),
          @factory.webclient_version_exists_check(),
        ])

        add_runtime_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.screen_service_running_check(),
          @factory.menu_service_running_check(),
          @factory.activity_service_running_check(),
          @factory.userPrefs_service_running_check(),
          @factory.elasticSearch_service_running_check(),
        ])

        add_pre_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
          @factory.credential_check(),
        ])

        add_post_update_checks([
          @factory.install_dir_exists_check(),
          @factory.disk_space_check(),
        ])
      end

    end
  end