class webclient(String $module_id) {

  $data = abas::inspect($module_id)
  $config = $data['config']

  $install_dir = $config['install_dir']

  $extra_hosts = $data['hosts']

  $registry_credentials   = abas::credentials($config['registry_credentials'])
  $registry_username      = $registry_credentials['username']
  $registry_password      = $registry_credentials['password']

  exec { "login":
    onlyif => ["[ $registry_username ] && [ $registry_password ] || exit 1"],
    command => "docker login docker.registry.abas.sh -u '$registry_username' -p '$registry_password'",
    logoutput => true,
    path => "/usr/bin",
  }->

  exec { "create install dir":
    command => "mkdir -p $install_dir",
    path => "/bin",
  }->

  webclient::install_services { 'install services':
    data    => $data,
  }->

  exec { "start webclient":
    command => "docker-compose up -d",
    cwd => $install_dir,
    path => "/usr/local/bin",
  }->

  exec { 'DOCKER: Logout from docker.registry.abas.sh':
    command   => "docker logout docker.registry.abas.sh",
    logoutput => true,
    path      => '/usr/bin',
  }
}
