define webclient::install_services($data) {

  $config = $data['config']

  $install_dir    = $config['install_dir']
  $prefs_srv_port = $config['prefs_srv_port']
  $screen_srv_port = $config['screen_srv_port']
  $ucm_srv_port = $config['ucm_srv_port']
  $activity_srv_port = $config['activity_srv_port']
  $elastic_search_port1 = $config['elastic_search_port1']
  $elastic_search_port2 = $config['elastic_search_port2']
  $webclient_version = $config['version']
  $rest_api_protocol = $config['rest_api']['protocol']
  $rest_api_host = $config['rest_api']['host']
  $rest_api_port = $config['rest_api']['port']

  $hostname = $data['extout']['hostname']
  $extra_hosts = $data['hosts']

  $service_versions = $data['extras']['service_versions']
  $prefs_srv_version = $service_versions['prefs_srv_version']
  $screen_srv_version = $service_versions['screen_srv_version']
  $activity_srv_version = $service_versions['activity_srv_version']
  $ucm_srv_version = $service_versions['ucm_srv_version']

  file { "${install_dir}/docker-compose.yml":
    ensure  => file,
    content => template("webclient/docker-compose.yml.erb"),
  }->

  file { "${install_dir}/config_menu_service.json":
    ensure  => file,
    content => template("webclient/config_menu_service.json.erb"),
  }->

  file { "${install_dir}/config_screen_service.json":
    ensure  => file,
    content => template("webclient/config_screen_service.json.erb"),
  }->

  file { "${install_dir}/webclient-version.yml":
    ensure  => file,
    content => template("webclient/webclient-version.yml.erb"),
  }->

  exec { "pull containers":
    command => "docker-compose pull",
    cwd => $install_dir,
    path => "/usr/local/bin",
    timeout => 900  # 900 secs = 15 minutes, default=300 secs
  }
}
