class webclient::update(String $module_id) {

  $data               = abas::inspect($module_id)
  $config             = $data['config']
  $install_dir        = $config['install_dir']
  $user               = $config['user']
  $extra_hosts        = $data['hosts']

  exec { 'DOCKER: Stop and remove containers':
    command => 'docker-compose down',
    cwd     => $install_dir,
    path    => '/usr/local/bin',
    user    => $user,
  }

  -> webclient::install_services { 'install_services':
    data    => $data,
  }

  exec { "start webclient":
    command => "docker-compose up -d",
    cwd => $install_dir,
    path => "/usr/local/bin",
  }
}
