# The abas webserver on-premise module

This module is used to install a webserver at a customer's end. This can than serve static UI resources from other modules that this module is made aware of. 

Currently nginx at version 1.14.2 is being supported.

A minimal abas file entry for this modeule can look like below. The oauth2 module is also shown as it needs the type keycloak set if you
are installing any other module than "freetexteditor". The "registry_credentials" parameter needs to reference the repository username password
for your company in the "Credentials" section of abasfile or from the credential.yml file created next to your abasfile.

```yaml
  oauth2:
    Type: abas::oauth2
    Host: main
    Properties:
      name: keycloak-type
      keycloak: keycloak
      type: keycloak

  webserver:
    Type: abas::webserver
    Host: main
    Properties:
      install_dir: /opt/abas-webserver
      project_name: install_test
      user: webserver_owner
      oauth2: oauth2
      http_port: 8181
      https_port: 4443
      registry_credentials: reg_cred_for_priv_read
      modules_to_host:
        bpm: bpm
        freetexteditor: freetexteditor
```

The abasfile entry for this module can look like this with the depending oauth module entry reference also shown:

```yaml
  webserver:
    Type: abas::webserver
    Host: main
    Properties:
      install_dir: /opt/abas-webserver
      project_name: install_test
      user: webserver_owner
      oauth2: oauth2
      registry_credentials: reg_cred_for_priv_read
      http_port: 8181
      https_port: 4443
      secure_mode: true
      certificate_subject: /C=DE/ST=BW/L=Karlsruhe/O=abas/OU=IT
      modules_to_host:
        bpm: bpm
        freetexteditor: freetexteditor
  
  oauth2:
    Type: abas::oauth2
    Host: main
    Properties:
      name: keycloak-type
      keycloak: keycloak
      type: keycloak
```

## The abas webserver default input parameters

The default ports feature is being turned off. Ports have to be provided manually.

The following are optional input parameters and can be excluded and resonable defaults are provided.

* "debug_mode" has a default value of "false"
* "http_port" has a default value of 80
* "https_port" has a default value of 443
* "secure_mode" has a default value of false

# The Module dependencies 

The Abas Webserver module is dependant on the following modules for a valid configuration. See the documentation of these listed modules for the correct configuration:

* abas::oauth2
* abas::keycloak : Indirectly via oauth2 if you are installing webserver for on premise usecase.
* abas::bpm
* abas::webclient
* abas::freetexteditor


## The abas webserver outputs description

**hostname**
This will just give you the fully qualified domain name of the machine where the web server is running.

**webroot**
This is the absolute path/location on the host machine from which the running web server serves the  web artifacts.

**webserver_confd_dir**
This is the absolute path/location on the host machine from which the running web server can load individualized *.conf files. This can be needed for e.g when
you have a special need to map certain locations to certain folders in your web artifacts directory structure. Or provide generally some other webserver specific parameters.
See nginx configuration files help for more on writing a conf file for your app.