require File.join(File.dirname(__FILE__), 'constants')

module AbasWebserver
    class DerivedConstants

        attr_reader :INSTALL_DIR, :WEBSERVER_DIR, :DOCKER_COMPOSE_DIR, :WEBROOT_DIR, :WEBSERVER_CONFD_DIR, 
                    :WEBSERVER_CONF_FILE_PATH, :WEBSERVER_ABAS_CONFD_DIR,
                    :WEBSERVER_DEFAULT_WWW_CONF_FILE_PATH, :CERTIFICATES_DIR, :BACKUP_DIR,
                    :WEBSERVER_CONF_DIR

        def initialize(install_dir:, project_name:)
            @INSTALL_DIR         = install_dir
            @WEBSERVER_DIR       = File.join(@INSTALL_DIR ,AbasWebserver::Constants::WEBSERVER_DIR_NAME).freeze
            @DOCKER_COMPOSE_DIR  = @WEBSERVER_DIR.freeze
            @WEBROOT_DIR         = File.join(@WEBSERVER_DIR,AbasWebserver::Constants::WEBROOT_DIR_NAME).freeze
            @WEBSERVER_CONF_DIR  = File.join(@WEBSERVER_DIR,AbasWebserver::Constants::WEBSERVER_CONF_DIR_NAME).freeze
            @WEBSERVER_CONFD_DIR = File.join(@WEBSERVER_CONF_DIR,AbasWebserver::Constants::WEBSERVER_CONFD_DIR_NAME).freeze

            @WEBSERVER_CONF_FILE_PATH             = File.join(@WEBSERVER_CONF_DIR,AbasWebserver::Constants::NGINX_CONF_FILE_NAME)
            @WEBSERVER_ABAS_CONFD_DIR             = File.join(@WEBSERVER_CONFD_DIR,AbasWebserver::Constants::WEBSERVER_ABAS_CONFD_DIR_NAME)
            @WEBSERVER_DEFAULT_WWW_CONF_FILE_PATH = File.join(@WEBSERVER_CONFD_DIR,AbasWebserver::Constants::NGINX_DEFAULT_WWW_CONF_FILENAME)
            @CERTIFICATES_DIR                     = File.join(@WEBSERVER_DIR,AbasWebserver::Constants::CERTIFICATES_DIR_NAME)
            @BACKUP_DIR                           = File.join(@INSTALL_DIR,AbasWebserver::Constants::BACKUP_DIR_NAME)
            @MODULE_KEYS_ARRAY = [AbasWebserver::Constants::BPM_MODULE_KEY, 
                                  AbasWebserver::Constants::DASHBOARD_MODULE_KEY, 
                                  AbasWebserver::Constants::WEB_CLIENT_MODULE_KEY, 
                                  AbasWebserver::Constants::FREE_TEXT_EDITOR_MODULE_KEY,
                                  AbasWebserver::Constants::REST_API_MODULE_KEY,
                                  AbasWebserver::Constants::USER_ADMINISTRATION_MODULE_KEY]
        end

        def module_keys_array
            return @MODULE_KEYS_ARRAY.clone
        end
    end
end 
