# abas_webserver.rb
require 'yaml' # import
require File.join(File.dirname(__FILE__), '../', 'derived_constants')
require File.join(File.dirname(__FILE__), '../', 'constants')
module AbasWebserver
  class AbasWebserverService

    RUNNING = :running
    STOPPED = :stopped
    MISSING = :missing
    FAILURE = :failure

    def initialize(resolved_config)
        @resolved_config = resolved_config
        @install_dir = resolved_config['install_dir']
        @DerivedConstants = AbasWebserver::DerivedConstants.new(install_dir: @install_dir, 
                                                                project_name: resolved_config['project_name']).freeze
    end

    def exists?
        return File.file?(File.join(@DerivedConstants.DOCKER_COMPOSE_DIR, "docker-compose.yml"))
    end

    def status
      if exists?
        result = system("cd #{@DerivedConstants.DOCKER_COMPOSE_DIR} && docker ps -q --no-trunc --filter status=running | grep -q $(docker-compose ps -q #{@AbasWebserver::Constants::DOCKER_COMPOSE_SERVICE_NAME})")
        if ( result )
          return RUNNING
        else
          return STOPPED
        end
      end
    end

    def start
      `cd #{@DerivedConstants.DOCKER_COMPOSE_DIR} && ./service.sh --up -- --force-recreate`
    end

    def stop
      `cd #{@DerivedConstants.DOCKER_COMPOSE_DIR} && ./service.sh --down`
    end
  end
end