# This is the resource to create the dashboard module configuration.
define webserver::configure_dashboard($data) {

  # Direct Input Variables defined by the user in abasfile
  $config                             = $data['config']
  $dashboard                          = $config['modules_to_host']['dashboard']

  if $dashboard != undef {
    $dashboard_context_path           = $dashboard['context_path']
    $dashboard_transfer_protocol      = $dashboard['transfer_protocol']
    $dashboard_host_ip                = $dashboard['host_ip']
    $dashboard_port                   = $dashboard['dashboard_api_port']
    $webserver_abas_confd_dir         = $data['extras']['webserver_abas_confd_dir']

    file { "${webserver_abas_confd_dir}/dashboard.conf":
      ensure  => file,
      content => template('webserver/dashboard.conf.erb'),
      mode    => '0440',
    }
  }
}
