# This is the resource to create the rest_api module configuration.
define webserver::configure_rest_api($data) {

  # Direct Input Variables defined by the user in abasfile
  $config                      = $data['config']
  $rest_api                    = $config['modules_to_host']['rest_api']

  if $rest_api != undef {
    $rest_api_path                   = $rest_api['path']
    $rest_api_protocol               = $rest_api['protocol']
    $rest_api_host_ip                = $rest_api['host_ip']
    $rest_api_port                   = $rest_api['port']
    $webserver_abas_confd_dir        = $data['extras']['webserver_abas_confd_dir']

    file { "${webserver_abas_confd_dir}/rest_api.conf":
      ensure  => file,
      content => template('webserver/rest_api.conf.erb'),
      mode    => '0440',
    }
  }
}
