# This is the resource to create the webclient module configuration.
define webserver::configure_webclient($data) {

  # Direct Input Variables defined by the user in abasfile
  $config                      = $data['config']
  $webclient                    = $config['modules_to_host']['webclient']

  if $webclient != undef {
    $webclient_context_path           = $webclient['context_path']
    $webclient_host_ip                = $webclient['host_ip']
    $webclient_port                   = $webclient['port']

    $webclient_transfer_protocol  = $webclient['transfer_protocol']
    $screen_srv_context_path      = $webclient['screen_srv_context_path']
    $screen_srv_port              = $webclient['screen_srv_port']
    $ucm_srv_context_path         = $webclient['ucm_srv_context_path']
    $ucm_srv_port                 = $webclient['ucm_srv_port']
    $prefs_srv_context_path       = $webclient['prefs_srv_context_path']
    $prefs_srv_port               = $webclient['prefs_srv_port']
    $activity_srv_context_path    = $webclient['activity_srv_context_path']
    $activity_srv_port            = $webclient['activity_srv_port']

    $webserver_abas_confd_dir        = $data['extras']['webserver_abas_confd_dir']

    file { "${webserver_abas_confd_dir}/webclient.conf":
      ensure  => file,
      content => template('webserver/webclient.conf.erb'),
      mode    => '0440',
    }
  }
}
