# This is the download public html content download script
define webserver::download_web_artifacts($data) {

  # Direct Input Variables defined by the user in abasfile
  $config                      = $data['config']
  $maven_artifacts_array       = $data['extras']['maven_artifacts_array']

  # Repo download variables
  $registry_credentials            = abas::credentials($data['config']["registry_credentials"])
  $registry_username               = $registry_credentials["username"]
  $registry_password               = $registry_credentials["password"]
  $webroot_dir                     = $data['extras']['webroot_dir']
  $webserver_abas_confd_dir        = $data['extras']['webserver_abas_confd_dir']
  $needed_packages = [ 'curl', 'unzip']

  package { $needed_packages:
    ensure => 'present',
  }
  $maven_artifacts_array.each |Integer $index, Hash $maven_artifact_map| {
    if $maven_artifact_map['web_context'] {
      $download_dir = "${webroot_dir}/${maven_artifact_map['web_context']}/tmp${index}"
      $unzip_dir = "${webroot_dir}/${maven_artifact_map['web_context']}"
    }
    else {
      $download_dir = "${webroot_dir}/tmp${index}"
      $unzip_dir = $webroot_dir
    }
    exec {"Creating temp folder to download maven artifact \"${maven_artifact_map['artifact_url']}\"" :
        command => "mkdir -p ${download_dir}",
        path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
    }
    -> exec {"Downloading the maven artifact ${maven_artifact_map['artifact_url']}" :
      command     => "curl -s -f -u \"\${REGISTRY_USERNAME}:\${REGISTRY_PASSWORD}\" -X GET ${maven_artifact_map['artifact_url']} -O -J --max-time 1800",
      cwd         => $download_dir,
      path        => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
      environment => [ "REGISTRY_USERNAME=${registry_username}", "REGISTRY_PASSWORD=${registry_password}"],
      logoutput   => true,
    }
    -> exec {"Unzipping the maven artifact \"${maven_artifact_map['artifact_url']}\"" :
      command   => "unzip -q -o *.zip -d \"${unzip_dir}\"",
      cwd       => $download_dir,
      path      => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
      logoutput => 'on_failure',
    }
    -> exec {"Moving the nginx conf for artifact \"${maven_artifact_map['artifact_url']}\" (if it exists) " :
      command   => "find ${unzip_dir} -maxdepth 1 -type f -name '*.conf' -exec mv '{}' ${webserver_abas_confd_dir} \\;",
      cwd       => $download_dir,
      path      => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
      logoutput => 'on_failure',
    }
    -> exec {"Delete the temporary download directory ${download_dir}" :
      command => "rm -rf ${download_dir}",
      path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
    }
  }
}
