# This is the the http manifest class that loads all configurations from Extra.rb and proceed to setup webserver.
class webserver(String $module_id) {

  $data = abas::inspect($module_id)

  # Direct Input Variables defined by the user in abasfile
  $config                   = $data['config']
  $user                     = $data['config']['user']
  $install_dir              = $config['install_dir']

  $needed_packages = [ 'bash' ]

  package { $needed_packages:
    ensure => 'present',
  }
  -> user { "Creating ${user}":
    ensure     => 'present',
    name       => $user,
    managehome => true,
    groups     => ['docker'],
  }
  -> exec {'Creating installation directory':
    command => "mkdir -p ${install_dir}",
    onlyif  => "test ! -d ${install_dir}",
    # If an existing directory with content is taken for install, refuse to install. TODO
    # unless  => "find \"${install_dir}\" -mindepth 1 -print -quit 2>/dev/null | grep -q .", 
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> exec { 'Change ownership of install directory':
    command => "chown -R ${user} ${install_dir}",
    path    => '/usr/bin:/bin:/usr/local/bin',
    cwd     => $install_dir,
  }
  -> webserver::install_webserver { 'Install the webserver':
    data    => $data,
  }
}
