# The update webserver class
class webserver::update(String $module_id) {

  $data                  = abas::inspect($module_id)
  $config                = $data['config']
  $install_dir           = $config['install_dir']
  $webserver_dir         = $data['extras']['webserver_dir']
  $webserver_backup_dir  = $data['extras']['webserver_backup_dir']
  $certificates_dir      = $data['extras']['certificates_dir']
  $certificates_dir_name = $data['extras']['certificates_dir_name']
  $user                  = $config['user']

  exec {'DOCKER: Stop and remove containers':
    command   => 'docker-compose down || :',
    cwd       => $webserver_dir,
    path      => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
    user      => $user,
    logoutput => 'on_failure'
  }
  -> exec {'Creating backup directory for existing installation':
    command => "mkdir -p ${webserver_backup_dir}",
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin',
  }
  -> exec {'Backup current webserver directory':
    command => "mv * ${webserver_backup_dir} || :",
    cwd     => $webserver_dir,
    path    => '/usr/bin:/usr/sbin:/bin:/usr/local/bin'
  }
  -> webserver::install_webserver { 'Update/Install the webserver':
    data    => $data,
  }
}
