module AbasWebserver
    class MavenArtifact
        attr_reader :artifact_url, :web_context

        def initialize( module_name: , repo_base_url: , maven_coordinate: , web_context: )
            @web_context = web_context
            @splitted_maven_coordinate = maven_coordinate.strip.split(':')
            # Replace the '.' in the group_id with '/' in place.
            @splitted_maven_coordinate[1].gsub!(/\./, '/')

            # The url format is of the form:
            # DOWNLOAD_URL="${REPO_BASE_URL}/${REPOSITORY}/${GROUPID}/${ARTIFACTID}/${VERSION}/${ARTIFACTID}-${VERSION}.zip"
            # And splitted coordinate has in index order the REPOSITORY, GROUPID, ARTIFACTID, VERSION from 0 to 3
            @artifact_url =   repo_base_url + '/' + @splitted_maven_coordinate.join("/") + '/' + @splitted_maven_coordinate[2] + '-' + @splitted_maven_coordinate[3] + '.zip'
            @webserver_conf_filename = module_name + '.conf'
        end

        def to_h
            hash = Hash.new
            hash['artifact_url'] = @artifact_url
            hash['web_context'] = @web_context 
            hash['webserver_conf_filename'] = @webserver_conf_filename
            return hash
        end
    end
end