
require File.join(File.dirname(__FILE__), 'derived_constants')
require File.join(File.dirname(__FILE__), 'util')

module AbasWebserver
  class Outputs

    def initialize(module_data)
      @config               = module_data['config']
      @host                 = module_data['host']
      @DerivedConstants = AbasWebserver::DerivedConstants.new(install_dir: @config['install_dir'], 
                                                              project_name: @config['project_name'] ).freeze
    end

    def hostname
      return @host['Properties']['hostname']
    end

    def install_dir
      return @DerivedConstants.INSTALL_DIR
    end

    def webroot
      return @DerivedConstants.WEBROOT_DIR
    end

    def webserver_dir
      return @DerivedConstants.WEBSERVER_DIR
    end

    def webserver_confd_dir
      return @DerivedConstants.WEBSERVER_CONFD_DIR
    end

    def webserver_base_url
      return AbasWebserver::Util.webserver_base_url(secure_mode: @config['secure_mode'] , 
                                                    hostname: @host["Properties"]["hostname"], 
                                                    http_port: @config['http_port'], 
                                                    https_port: @config['https_port'])
    end
  end
end