# abas_webserver.rb
require File.join(File.dirname(__FILE__), 'constants')
require File.join(File.dirname(__FILE__), 'derived_constants')

module AbasWebserver
  class Validation

    def initialize(module_data)
      #@log = AbasLogger.instance 
      # eg: @log.debug() @log.info() 
      @host = module_data['host']
      @config = module_data['resolved_config']  
      @DerivedConstants = AbasWebserver::DerivedConstants.new(install_dir: @config['install_dir'],
                                                              project_name: @config['project_name'] )  
    end

    def validate_oauth2
      result = Hash.new
      result[:valid] = true
      modules_to_host_keys = (@config['modules_to_host'].reject { |k,v| v.nil? || v.empty? }).keys
      # remove freetexteditor if present from the key, as it does not need oauth2
      modules_to_host_keys = modules_to_host_keys - [ AbasWebserver::Constants::FREE_TEXT_EDITOR_MODULE_KEY ]
      if modules_to_host_keys.length > 0
        if @config['oauth2'] == nil
          result[:valid] = false 
          result[:message] = "You have choosen to host modules " + modules_to_host_keys.to_s + " on the webserver. This requires the 'oauth2' module and the 'keycloak' module which are not configured. " +
                             "Please configure the missing modules and try again."
        else
          @on_premise = @config['oauth2']['type'] == 'keycloak'
          if @on_premise == false 
            result[:valid] = false
            result[:message] = "The webserver module requires that you configure 'oauth2' module's input parameter 'type' with a value of 'keycloak'. " +
                              "Additionally the 'keycloak' module should also be configured and installed. Please correct your configurations and try again."
          end
        end
      end
      return result
    end

  end
end
